#include <iostream>
#include <algorithm>
using namespace std;

int main()
{
    int n;
    cin>>n;
    int a[n],b[n],c[n];
    int ind;
    bool promenio=false;
    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        b[i]=a[i];
    }
    sort(b,b+n);
    reverse(b,b+n);
    int pom;
    for(int i=0;i<n;i++)
    {
        if(a[i]!=b[i])
        {
             for(int j=i;j<n;j++)
             {
                 if(a[j]==b[i] && a[j]!=b[j])
                 {
                     pom=a[j];
                     a[j]=a[i];
                     a[i]=pom;
                     promenio=true;
                 }
             }
             break;
        }
    }
    bool isti=false;
    if(!promenio)
    {
        for(int i=0;i<n-1;i++)
        {
            if(b[i]==b[i+1])
            {   
                isti=true;
                break;
            }
        }
        if(!isti)
        {
            pom=a[n-1];
            a[n-1]=a[n-2];
            a[n-2]=pom;   
        }
    }

    for(int i=0;i<n;i++)
    {
        cout<<a[i]<<" ";
    }
    
    
    return 0;
}